=== doc/CMakeLists.txt ===
file(GLOB DOC_FILES
	${CMAKE_CURRENT_SOURCE_DIR}/*.gif
	${CMAKE_CURRENT_SOURCE_DIR}/*.png
	${CMAKE_CURRENT_SOURCE_DIR}/LICENSE*.txt
	${CMAKE_CURRENT_SOURCE_DIR}/LGPL.txt
	${CMAKE_CURRENT_SOURCE_DIR}/index.html
	${CMAKE_CURRENT_SOURCE_DIR}/virtualgl.css)

install(FILES ${DOC_FILES} ${CMAKE_SOURCE_DIR}/ChangeLog.md
	DESTINATION ${CMAKE_INSTALL_DOCDIR})
