=== debian/changelog ===
virtualgl (2.5.2-1mx17+1) mx; urgency=medium

  * New upstream release.
  * Refresh remove-glxinfo.patch.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 09 Nov 2017 13:02:45 -0800

virtualgl (2.5.1-1mx15+1) mx; urgency=medium

  * New upstream release; build for MX 15.
  * debian/control: change build-dep to libturbojpeg0-dev.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 10 Nov 2016 13:06:02 -0800

virtualgl (2.4.1-1~trustyppa1) trusty; urgency=medium

  * New upstream release.

 -- Vincent Cheng <vcheng@debian.org>  Sat, 15 Aug 2015 00:18:59 -0700

virtualgl (2.3.3-1~trustyppa1) trusty; urgency=low

  * Initial release for Trusty

 -- Bruno Pagani <bruno.n.pagani@gmail.com>  Mon, 13 Jan 2014 20:22:24 +0200
