## virtualgl 2.6.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 cmake_minimum_required(VERSION 2.8.11)
 # Shut up CMake 3.1 and later
 if(POLICY CMP0053)
-	cmake_policy(SET CMP0053 OLD)
+	cmake_policy(SET CMP0053 NEW)
 endif()
 
 if(WIN32)
@@ -14,7 +14,8 @@
 	project(VirtualGL)
 endif()
 string(TOLOWER ${CMAKE_PROJECT_NAME} CMAKE_PROJECT_NAME_LC)
-set(VERSION 2.5.2)
+set(VERSION 2.6.2)
+set(DOCVERSION 2.6.2)
 
 macro(boolean_number var)
 	if(${var})
@@ -71,10 +72,14 @@
 	if(NOT CMAKE_SYSTEM_PROCESSOR STREQUAL ${CPU_TYPE})
 		set(CMAKE_SYSTEM_PROCESSOR ${CPU_TYPE})
 	endif()
+elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL "ppc64" AND BITS EQUAL 32)
+	set(CPU_TYPE ppc)
+	set(CMAKE_SYSTEM_PROCESSOR ${CPU_TYPE})
 else()
 	set(CPU_TYPE ${CMAKE_SYSTEM_PROCESSOR_LC})
 endif()
 message(STATUS "${BITS}-bit build (${CPU_TYPE})")
+add_definitions(-D__BITS=${BITS})
 
 if(UNIX)
 	set(CMAKE_INSTALL_DEFAULT_PREFIX /opt/${CMAKE_PROJECT_NAME})
@@ -150,9 +155,9 @@
 	# Don't auto-generate manifests
 	set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /MANIFEST:NO")
 
-  # Avoid linker warning when doing Debug build if dependent libraries are
-  # linked with the Release version of the static C library.
-  set(CMAKE_EXE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} /NODEFAULTLIB:LIBCMT")
+	# Avoid linker warning when doing Debug build if dependent libraries are
+	# linked with the Release version of the static C library.
+	set(CMAKE_EXE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} /NODEFAULTLIB:LIBCMT")
 endif()
 
 # This ensures that we don't depend on libstdc++ or libgcc
@@ -168,7 +173,8 @@
 			--print-file-name=libstdc++.a OUTPUT_VARIABLE LIBSTDCPLUSPLUS
 			RESULT_VARIABLE RESULT)
 		string(REGEX REPLACE "\n" "" LIBSTDCPLUSPLUS ${LIBSTDCPLUSPLUS})
-		if(RESULT MATCHES 0 AND LIBSTDCPLUSPLUS)
+		if(RESULT MATCHES 0 AND LIBSTDCPLUSPLUS AND
+			NOT LIBSTDCPLUSPLUS STREQUAL "libstdc++.a")
 			message(STATUS "Linking with static libstdc++:\n   ${LIBSTDCPLUSPLUS}")
 			file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/staticlib)
 			execute_process(COMMAND ${CMAKE_COMMAND} -E remove
@@ -237,6 +243,37 @@
 	endif()
 endif()
 
+include(CheckCSourceCompiles)
+if(MSVC)
+	set(INLINE_OPTIONS "__inline;inline")
+else()
+	set(INLINE_OPTIONS "__inline__;inline")
+endif()
+option(VGL_FORCEINLINE "Force function inlining" TRUE)
+boolean_number(VGL_FORCEINLINE)
+if(VGL_FORCEINLINE)
+	if(MSVC)
+		list(INSERT INLINE_OPTIONS 0 "__forceinline")
+	else()
+		list(INSERT INLINE_OPTIONS 0 "inline __attribute__((always_inline))")
+		list(INSERT INLINE_OPTIONS 0 "__inline__ __attribute__((always_inline))")
+	endif()
+endif()
+foreach(inline ${INLINE_OPTIONS})
+	check_c_source_compiles("${inline} static int foo(void) { return 0; } int main(void) { return foo(); }"
+		INLINE_WORKS)
+	if(INLINE_WORKS)
+		set(INLINE ${inline})
+		break()
+	endif()
+endforeach()
+if(NOT INLINE_WORKS)
+	message(FATAL_ERROR "Could not determine how to inline functions.")
+endif()
+message(STATUS "INLINE = ${INLINE} (VGL_FORCEINLINE = ${VGL_FORCEINLINE})")
+configure_file(include/vglinline.h.in include/vglinline.h)
+include_directories(${CMAKE_BINARY_DIR}/include)
+
 option(VGL_USESSL
 	"Enable SSL (Secure Sockets Layer) encryption feature in the VGL Transport"
 	OFF)
@@ -265,6 +302,9 @@
 	set(CMAKE_LIBRARY_PATH /usr/lib/${CPU_TYPE}-linux-gnu;/usr/lib${BITS};/usr/lib)
 endif()
 include(FindX11)
+# Clarify that we need to link with the legacy OpenGL library (libGL) rather
+# than the GLVND OpenGL library.  This shuts up CMake 3.11 and later.
+set(OpenGL_GL_PREFERENCE LEGACY)
 include(FindOpenGL)
 
 # Ensure that we build and link against the X11 version of OpenGL on OS X
@@ -276,9 +316,9 @@
 		set(CMAKE_SHARED_LINKER_FLAGS
 			"${CMAKE_SHARED_LINKER_FLAGS} -Wl,-dylib_file,/System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries/libGL.dylib:/System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries/libGL.dylib")
 	endif()
-	set(X11_X11_INCLUDE_PATH /usr/X11R6/include)
-	set(OPENGL_gl_LIBRARY /usr/X11R6/lib/libGL.dylib)
-	set(OPENGL_glu_LIBRARY /usr/X11R6/lib/libGLU.dylib)
+	set(X11_X11_INCLUDE_PATH /usr/X11/include)
+	set(OPENGL_gl_LIBRARY /usr/X11/lib/libGL.dylib)
+	set(OPENGL_glu_LIBRARY /usr/X11/lib/libGLU.dylib)
 endif()
 
 # Not all OpenGL installations include all of the prototypes and constants in
@@ -323,52 +363,3 @@
 message(STATUS "Compiler flags = ${EFFECTIVE_C_FLAGS}")
 
 set(EFFECTIVE_LD_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${CMAKE_EXE_LINKER_FLAGS_${CMAKE_BUILD_TYPE_UC}}")
-message(STATUS "Linker flags = ${EFFECTIVE_LD_FLAGS}")
-
-
-###############################################################################
-# TARGETS
-###############################################################################
-
-if(NOT WIN32)
-
-if(VGL_BUILDSERVER)
-	set(DEFAULT_VGL_FAKER_NAME vglfaker)
-	set(VGL_FAKER_NAME ${DEFAULT_VGL_FAKER_NAME} CACHE STRING
-		"Base name for VirtualGL's GLX/OpenGL/X11 interposer library (default: ${DEFAULT_VGL_FAKER_NAME})")
-
-	set(DEFAULT_VGL_DLFAKER_NAME dlfaker)
-	set(VGL_DLFAKER_NAME ${DEFAULT_VGL_DLFAKER_NAME} CACHE STRING
-		"Base name for VirtualGL's dlopen() interposer library (default: ${DEFAULT_VGL_DLFAKER_NAME})")
-
-	set(DEFAULT_VGL_GEFAKER_NAME gefaker)
-	set(VGL_GEFAKER_NAME ${DEFAULT_VGL_GEFAKER_NAME} CACHE STRING
-		"Base name for VirtualGL's getenv() interposer library (default: ${DEFAULT_VGL_GEFAKER_NAME})")
-
-	set(CMAKE_POSITION_INDEPENDENT_CODE 1)
-endif()
-
-set(FBXLIB fbx)
-if(VGL_USEXV)
-	set(FBXLIB ${FBXLIB};fbxv)
-endif()
-
-add_subdirectory(util)
-add_subdirectory(common)
-if(VGL_BUILDSERVER)
-	add_subdirectory(server)
-endif()
-add_subdirectory(client)
-add_subdirectory(glxdemos)
-add_subdirectory(diags)
-add_subdirectory(doc)
-
-else()
-
-install(FILES LICENSE.txt LGPL.txt DESTINATION ${CMAKE_INSTALL_DOCDIR})
-
-endif() # WIN32
-
-
-###############################################################################
-# INSTALLATION AND PACKAGING
