=== server/CMakeLists.txt ===
--- 
+++ 
@@ -125,13 +125,15 @@
 set(HEADERS ../common/rr.h rrtransport.h)
 install(FILES ${HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
 
-include_directories(${FLTK_INCLUDE_DIR})
+include_directories(SYSTEM ${FLTK_INCLUDE_DIR})
 add_executable(vglconfig vglconfig.cpp fakerconfig.cpp)
 target_link_libraries(vglconfig ${X11_X11_LIB} ${FLTK_BASE_LIBRARY} vglutil)
 if(VGL_USEXV)
 	target_link_libraries(vglconfig ${X11_Xv_LIB})
 endif()
 install(TARGETS vglconfig DESTINATION ${CMAKE_INSTALL_BINDIR})
+set_property(SOURCE vglconfig.cpp APPEND_STRING PROPERTY COMPILE_FLAGS
+	"-fno-strict-aliasing")
 
 install(PROGRAMS vglgenkey vgllogin vglserver_config DESTINATION
 	${CMAKE_INSTALL_BINDIR})
@@ -168,7 +170,8 @@
 
 if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
 	add_library(deepbindtest SHARED libdeepbindtest.c)
-	target_link_libraries(deepbindtest ${X11_X11_LIB} ${OPENGL_gl_LIBRARY})
+	target_link_libraries(deepbindtest ${X11_X11_LIB} ${OPENGL_gl_LIBRARY}
+		${LIBDL})
 	set_target_properties(deepbindtest PROPERTIES LINK_FLAGS "${MINUSZ}defs")
 endif()
 
@@ -194,4 +197,6 @@
 	target_link_libraries(vgltrans_test2 stdc++)
 endif()
 
-configure_file(servertest.in ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/servertest)
+configure_file(servertest.in ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/servertest
+	@ONLY)
+execute_process(COMMAND chmod +x ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/servertest)
