=== debian/changelog ===
virtualgl (2.6.2-0mx19+1) mx; urgency=medium

  * New Upstream release.

 -- Timothy E. Harris <maintainer@mxrepo.com>  Mon, 08 Jul 2019 09:56:54 -0400
