=== debian/control ===
Source: virtualgl
Section: utils
Priority: extra
Maintainer: Steven Pusser <stevep@mxlinux.org>
Bugs: mailto: <stevep@mxlinux.org>
XSBC-Original-Maintainer: The Bumblebee Project <bumblebee@lists.launchpad.net>
Uploaders: Peter Lekensteyn <lekensteyn@gmail.com>,
 Bruno Pagani <bruno.n.pagani@gmail.com>
Build-Depends: debhelper (>= 9), cmake (>= 2.8.11),
 libturbojpeg0-dev,
 libx11-dev,
 libxext-dev,
 libgl1-mesa-dev,
 libglu1-mesa-dev,
 libxv-dev
Standards-Version: 3.9.5
Homepage: http://www.virtualgl.org/
Vcs-Browser: http://virtualgl.svn.sourceforge.net/viewvc/virtualgl/vgl/

Package: virtualgl
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}, virtualgl-libs
Recommends: virtualgl-libs-ia32 [amd64]
Description: Toolkit for displaying OpenGL applications to thin clients
 VirtualGL is a toolkit that allows most Unix/Linux OpenGL applications to be
 remotely displayed with hardware 3D acceleration to thin clients, regardless
 of whether the clients have 3D capabilities, and regardless of the size of the
 3D data being rendered or the speed of the network.
 .
 Using the vglrun script, the VirtualGL "faker" is loaded into an OpenGL
 application at run time.  The faker then intercepts a handful of GLX calls,
 which it reroutes to the server's X display (the "3D X Server", which
 presumably has a 3D accelerator attached.)  The GLX commands are also
 dynamically modified such that all rendering is redirected into a Pbuffer
 instead of a window.  As each frame is rendered by the application, the faker
 reads back the pixels from the 3D accelerator and sends them to the
 "2D X Server" for compositing into the appropriate X Window.
 .
 VirtualGL can be used to give hardware-accelerated 3D capabilities to VNC or
 other X proxies that either lack OpenGL support or provide it through software
 rendering.  In a LAN environment, VGL can also be used with its built-in
 high-performance image transport, which sends the rendered 3D images to a
 remote client (vglclient) for compositing on a remote X server.  VirtualGL
 also supports image transport plugins, allowing the rendered 3D images to be
 sent or captured using other mechanisms.
 .
 VirtualGL is based upon ideas presented in various academic papers on
 this topic, including "A Generic Solution for Hardware-Accelerated Remote
 Visualization" (Stegmaier, Magallon, Ertl 2002) and "A Framework for
 Interactive Hardware Accelerated Remote 3D-Visualization" (Engel, Sommer,
 Ertl 2000.)

Package: virtualgl-libs
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Library files for virtualgl
 This package contains the libraries for virtualgl which are loaded when
 running vglrun.

Package: virtualgl-libs-ia32
Architecture: i386
Pre-Depends: ${misc:Pre-Depends}
Depends: virtualgl-libs, ${misc:Depends}
Multi-Arch: foreign
Description: Library files for virtualgl (32-bit)
 This package depends on 32-bit libraries for virtualgl. It can safely be
 removed after installation.

Package: virtualgl-dbg
Architecture: i386 amd64
Section: debug
Depends: virtualgl (=${binary:Version}), ${misc:Depends}
Description: VirtualGL - debugging symbols
 VirtualGL is a toolkit that allows most Unix/Linux OpenGL applications to be
 remotely displayed with hardware 3D acceleration to thin clients, regardless
 of whether the clients have 3D capabilities, and regardless of the size of the
 3D data being rendered or the speed of the network.
 .
 This package contains the debugging symbols for virtualgl.

Package: virtualgl-libs-dbg
Architecture: i386 amd64
Section: debug
Depends: virtualgl-libs (=${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: Library files for virtualgl - debugging symbols
 This package contains the libraries for virtualgl which are loaded when
 running vglrun.
 .
 This package contains the debugging symbols for virtualgl-libs.
